from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import random

import texMgr

crateTex=-1
stickerTextures={}
numberTextures={}

crates=[]

gGameOver=False


def init():
    global gGameOver
    gGameOver = False
    
    global crateTex
    crateTex = texMgr.loadTexture("data/crate.png")

    stickerColors=["red", "yellow", "green", "blue"]
    
    for c in stickerColors:
        stickerTextures[c]=texMgr.loadTexture("data/sticker_%s.png"%c)

    for i in range(1,21):
        numberTextures[i]=texMgr.loadTexture("data/number_%02d_tex.png"%i)

    for i in range(6):
        c=Crate(2*i)
        sticker_selection=random.sample(stickerColors,2)
        c1=random.randrange(2,10)
        c2=random.randrange(5,21)
        c.add_need(sticker_selection[0],c1)
        c.add_need(sticker_selection[1],c2)
        crates.append(c)


CRATEFUDGE = 4
LABEL_FUDGE_X = 8
LABEL_FUDGE_Y = 4

def drawCrates(board):
    for c in crates:
        c.draw(board)
"""    
    glBindTexture(GL_TEXTURE_2D, crateTex)

    
    for x in range(0, 12, 2):
        left=x*board.scale+board.bufferX+CRATEFUDGE
        right=left+2*board.scale-2*CRATEFUDGE
    
        bottom=0
        top=bottom+2*board.scale-2*CRATEFUDGE

        glBegin(GL_QUADS)
        glTexCoord2f(0.0, 1.0); glVertex2f(  left, top)
        glTexCoord2f(1.0, 1.0); glVertex2f( right, top)
        glTexCoord2f(1.0, 0.0); glVertex2f( right, bottom)
        glTexCoord2f(0.0, 0.0); glVertex2f(  left, bottom)
        glEnd()
"""    
    


class Crate:
    def __init__(self, x):
        self.x=x
        self.needLabels=[]

    def add_need(self, label, num):
        self.needLabels.append((num, label))

    def draw(self, board):
        glBindTexture(GL_TEXTURE_2D, crateTex)
        left=self.x*board.scale+board.bufferX+CRATEFUDGE
        right=left+2*board.scale-2*CRATEFUDGE
    
        bottom=0
        top=bottom+2*board.scale-2*CRATEFUDGE

        glBegin(GL_QUADS)
        glTexCoord2f(0.0, 1.0); glVertex2f(  left, top)
        glTexCoord2f(1.0, 1.0); glVertex2f( right, top)
        glTexCoord2f(1.0, 0.0); glVertex2f( right, bottom)
        glTexCoord2f(0.0, 0.0); glVertex2f(  left, bottom)
        glEnd()


        glColor4f(1.0, 1.0, 1.0, 0.8)
        left += LABEL_FUDGE_X
        right -= LABEL_FUDGE_X
        middle = (bottom+top)/2.0
        midtop = (3*top+bottom)/4.0
        midbot = (top+3*bottom)/4.0
        midX=(left+right)/2.0
        stickH=top-bottom-2*LABEL_FUDGE_Y
        numleft=midX-stickH/2
        numright=midX+stickH/2

        if (len(self.needLabels)==2):
            num,label=self.needLabels[0]
            glBindTexture(GL_TEXTURE_2D, stickerTextures[label])
            glColor4f(1.0, 1.0, 1.0, 0.8)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  left, top-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( right, top-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( right, middle+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  left, middle+LABEL_FUDGE_Y)
            glEnd()

            glBindTexture(GL_TEXTURE_2D, numberTextures[num])
            glColor4f(1.0, 1.0, 1.0, 1.0)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  numleft, top-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( numright, top-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( numright, middle+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  numleft, middle+LABEL_FUDGE_Y)
            glEnd()
                          

            num,label=self.needLabels[1]
            glBindTexture(GL_TEXTURE_2D, stickerTextures[label])
            glColor4f(1.0, 1.0, 1.0, 0.8)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  left, middle-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( right, middle-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( right, bottom+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  left, bottom+LABEL_FUDGE_Y)
            glEnd()

            glBindTexture(GL_TEXTURE_2D, numberTextures[num])
            glColor4f(1.0, 1.0, 1.0, 1.0)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  numleft, middle-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( numright, middle-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( numright, bottom+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  numleft, bottom+LABEL_FUDGE_Y)
            glEnd()
            
        elif (len(self.needLabels)==1):
            num,label=self.needLabels[0]
            glBindTexture(GL_TEXTURE_2D, stickerTextures[label])
            glColor4f(1.0, 1.0, 1.0, 0.8)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  left, midtop-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( right, midtop-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( right, midbot+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  left, midbot+LABEL_FUDGE_Y)
            glEnd()

            glBindTexture(GL_TEXTURE_2D, numberTextures[num])
            glColor4f(1.0, 1.0, 1.0, 1.0)
            glBegin(GL_QUADS)
            glTexCoord2f(0.0, 1.0); glVertex2f(  numleft, midtop-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 1.0); glVertex2f( numright, midtop-LABEL_FUDGE_Y)
            glTexCoord2f(1.0, 0.0); glVertex2f( numright, midbot+LABEL_FUDGE_Y)
            glTexCoord2f(0.0, 0.0); glVertex2f(  numleft, midbot+LABEL_FUDGE_Y)
            glEnd()
            
            


        glColor4f(1.0, 1.0, 1.0, 1.0)

    def enterBall(self, b):
        if not self.needLabels:
            return
        
        if b.color=='white':
            num,label=self.needLabels[0]
            self.needLabels[0]=(num-1,label)
        elif b.color=='black':
            for i in range(len(self.needLabels)):
                num,label=self.needLabels[i]
                newNum=min(num+1,20)
                self.needLabels[i]=newNum,label
        else:
            for i in range(len(self.needLabels)):
                num,label=self.needLabels[i]
                if b.color==label:
                    self.needLabels[i]=(num-1,label)

        self.needLabels=[s for s in self.needLabels
                           if s[0]>0]
                         
                

        

                    
            
        
def enterBall(board, b):
    column=int((b.x-board.bufferX)/board.scale)
    print "ball of color", b.color, "entering column",column

    for c in crates:
        if c.x==column or c.x+1==column:
            c.enterBall(b)
    

def update(dt):
    global crates

    crates=[c for c in crates if len(c.needLabels)>0]

    if not crates:
        global gGameOver
        gGameOver=True
        print "YOU WIN!!"
